local schema = require "model.schema"
local logger = require "logger"
local stringify = require "stringify"
local skynet = require "skynet"

local rankinglist
local module_name = "rankinglist"
local _M = schema.new(module_name, {
})

local REQUEST = {}
local CMD = {}
local MODULE = {}
local THIS = {}

local function func_ret(fname, character, args)
    local f = THIS[fname]
    if not f then
        logger.error("func_ret not fname:%s !!!", fname)
        return {errno = STD_ERR.COMMON_SYS_ERR}
    end
    local errno, ret = f(character, args)
    if errno ~= 0 then
        return {errno = errno}
    end
    ret = ret or {}
    ret.errno = 0
    return ret
end

function MODULE.list_request_interests() return REQUEST end
function MODULE.list_command_interests() return CMD end

-- TODO: 解析/升级模块数据 在这里把数据初始化好
function MODULE.parse(character)
    local d = _M.load(character)
end

-- TODO: 侦听事件
function MODULE.monitor(character)

end

-- TODO: 类似泰利的 prepare 接口
function MODULE.launch(character)
    rankinglist = skynet.localname(".rankinglist")
end

-- TODO: 与客户端同步数据
function MODULE.ready(character)

end

-- TODO: 玩家下线时的处理
function MODULE.saybye(character)

end

function THIS.ranking_data(character, args)
    if not args.type then
        return 1 -- 参数异常
    end

    local list = skynet.call(rankinglist, "lua", "get_ranking", args.type)

    local ret = {
        errno = 0,
        type = args.type,
        list = {},
    }

    for k, v in ipairs(list) do
        if k > 200 then
            break
        end
        v.ranking = k
        v.num2 = nil
        if k <= 100 then
            ret.list[k] = v
        end

        if v.role and v.role.uid == character.uid then
            ret.myslef = v
        end
    end
    return 0, ret
end

function REQUEST.ranking_data(character, args)
    return func_ret("ranking_data", character, args)
end

return MODULE